【BZOJ】1650: [Usaco2006 Dec]River Hopscotch 跳石子(二分+贪心)

http://www.lydsy.com/JudgeOnline/problem.php?id=1650

看到数据和最小最大时一眼就是二分。。。

但是仔细想想好像判断时不能贪心?

然后看题解还真是贪心。。囧。

原来是之前我脑残了。

。。。

贪心很简单

排序后。

当前点到之前的点的距离<m就累计(相当于删掉这个点,为什么呢?因为这个点假设last到的不是0,那么这个点删了后,因为后边的点的距离大于它,假设后边的点距离减去这个点的距离也是<m,那么显然删去这个点可以得到2个不用删去的点(否则一定要删去这两个点,这样就不是最优了)

否则之前的点变成当前点。。

#include <cstdio>
#include <cstring>
#include <cmath>
#include <string>
#include <iostream>
#include <algorithm>
#include <queue>
using namespace std;
#define rep(i, n) for(int i=0; i<(n); ++i)
#define for1(i,a,n) for(int i=(a);i<=(n);++i)
#define for2(i,a,n) for(int i=(a);i<(n);++i)
#define for3(i,a,n) for(int i=(a);i>=(n);--i)
#define for4(i,a,n) for(int i=(a);i>(n);--i)
#define CC(i,a) memset(i,a,sizeof(i))
#define read(a) a=getint()
#define print(a) printf("%d", a)
#define dbg(x) cout << #x << " = " << x << endl
#define printarr(a, n, m) rep(aaa, n) { rep(bbb, m) cout << a[aaa][bbb]; cout << endl; }
inline const int getint() { int r=0, k=1; char c=getchar(); for(; c<'0'||c>'9'; c=getchar()) if(c=='-') k=-1; for(; c>='0'&&c<='9'; c=getchar()) r=r*10+c-'0'; return k*r; }
inline const int max(const int &a, const int &b) { return a>b?a:b; }
inline const int min(const int &a, const int &b) { return a<b?a:b; }

const int N=50005;
int a[N], n, m, L;
bool check(int s) {
	int last=0, tot=0;
	for1(i, 1, n) {
		if(a[i]-a[last]<s) {
			++tot;
			if(tot>m) return false;
		}
		else last=i;
	}
	return true;
}
int main() {
	read(L); read(n); read(m);
	for1(i, 1, n) read(a[i]);
	sort(a+1, a+1+n);
	a[n+1]=L;
	int l=0, r=L;
	while(l<=r) {
		int m=(l+r)>>1;
		if(check(m)) l=m+1;
		else r=m-1;
	}
	print(l-1);
	return 0;
}

 

 


 

 

Description

Every year the cows hold an event featuring a peculiar version of hopscotch that involves carefully jumping from rock to rock in a river. The excitement takes place on a long, straight river with a rock at the start and another rock at the end, L units away from the start (1 <= L <= 1,000,000,000). Along the river between the starting and ending rocks, N (0 <= N <= 50,000) more rocks appear, each at an integral distance Di from the start (0 < Di < L). To play the game, each cow in turn starts at the starting rock and tries to reach the finish at the ending rock, jumping only from rock to rock. Of course, less agile cows never make it to the final rock, ending up instead in the river. Farmer John is proud of his cows and watches this event each year. But as time goes by, he tires of watching the timid cows of the other farmers limp across the short distances between rocks placed too closely together. He plans to remove several rocks in order to increase the shortest distance a cow will have to jump to reach the end. He knows he cannot remove the starting and ending rocks, but he calculates that he has enough resources to remove up to M rocks (0 <= M <= N). FJ wants to know exactly how much he can increase the shortest distance *before* he starts removing the rocks. Help Farmer John determine the greatest possible shortest distance a cow has to jump after removing the optimal set of M rocks.

数轴上有n个石子,第i个石头的坐标为Di,现在要从0跳到L,每次条都从一个石子跳到相邻的下一个石子。现在FJ允许你移走M个石子,问移走这M个石子后,相邻两个石子距离的最小值的最大值是多少。

Input

* Line 1: Three space-separated integers: L, N, and M * Lines 2..N+1: Each line contains a single integer indicating how far some rock is away from the starting rock. No two rocks share the same position.

Output

* Line 1: A single integer that is the maximum of the shortest distance a cow has to jump after removing M rocks

Sample Input

25 5 2
2
14
11
21
17

5 rocks at distances 2, 11, 14, 17, and 21. Starting rock at position
0, finishing rock at position 25.

Sample Output

4

HINT

   移除之前,最短距离在位置2的石头和起点之间;移除位置2和位置14两个石头后,最短距离变成17和21或21和25之间的4.

Source

 

posted @ 2014-09-07 14:42  iwtwiioi  阅读(411)  评论(0编辑  收藏  举报